/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2203 from the
 * contents of Hexdump.xs. Do not edit this file, edit Hexdump.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Hexdump.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define HEX_SZ (16*10 + 1)
#define CHR_SZ (16*8 + 1)

typedef struct {
	U8 row;
	U8 hpad;
	U8 cpad;
	U8 hsp;
	U8 csp;
	U8 cols;
} hexdump_conf;

static SV * myhexdump(char *data, STRLEN size, hexdump_conf *cf)
{
	/* dumps size bytes of *data to stdout. Looks like:
	 * [0000] 75 6E 6B 6E 6F 77 6E 20 30 FF 00 00 00 00 39 00 unknown 0.....9.
	 * src = 16 bytes.
	 * dst = 6       +  16 * 3   +      4*2         +  16       + 1
	 *       prefix    byte+pad    sp between col    visual     newline
	 */
	U8 row  = cf->row;
	U8 hpad = cf->hpad;
	U8 cpad = cf->cpad;
	U8 hsp  = cf->hsp;
	U8 csp  = cf->csp;
	U8 sp   = cf->cols;
	
	U8 every = (U8)row / sp;
	
	
	unsigned char *p = data;
	unsigned char c;
	STRLEN n;
	UV addr;
	char bytestr[4] = {0};
	char addrstr[10] = {0};
	char hexstr[ HEX_SZ ] = {0};
	char chrstr[ CHR_SZ ] = {0};
	STRLEN hex_sz = row*(2+hpad) + hsp * sp + 1; /* size = bytes<16*2> + 16*<hpad> + col<hsp*sp> */
	STRLEN chr_sz = row*(2+cpad) + csp * sp + 1; /* size = bytes<16> + 16*cpad + col<csp*sp> */
	SV * rv = newSVpvn("",0);
	
	if ( hex_sz > HEX_SZ ) {
		warn("Parameters too big: estimated hex size will be %d, but have only %d", hex_sz, HEX_SZ);
		return sv_newmortal();
	}
	if ( chr_sz > CHR_SZ ) {
		warn("Parameters too big: estimated chr size will be %d, but have only %d", chr_sz, CHR_SZ);
		return sv_newmortal();
	}
	
	STRLEN sv_sz = ( size + row-1 ) * ( (U8)( 6 + 3 + hex_sz + 2 + chr_sz + 1 + row-1 ) / row );
	/*                      ^ reserve for incomplete string             \n      ^ emulation of ceil */
	SvGROW(rv,sv_sz);
	
	char *curhex = hexstr;
	char *curchr = chrstr;
	for(n=1; n<=size; n++) {
		if (n % row == 1)
			snprintf(addrstr, sizeof(addrstr), "%04"UVxf, ( PTR2UV(p)-PTR2UV(data) ) & 0xffff );
		
		c = *p;
		if (c < 0x20 || c > 0x7f) {
			c = '.';
		}
		
		/* store hex str (for left side) */
		my_snprintf(curhex, 3+hpad, "%02X%-*s", *p, hpad,""); curhex += 2+hpad;
		
		/* store char str (for right side) */
		my_snprintf(curchr, 2+cpad, "%c%-*s", c, cpad, ""); curchr += 1+cpad;
		
		//warn("n=%d, row=%d, every=%d\n",n,row,every);
		if( n % row == 0 ) {
			/* line completed */
			//printf("[%-4.4s]   %s  %s\n", addrstr, hexstr, chrstr);
			sv_catpvf(rv,"[%-4.4s]   %s  %s\n", addrstr, hexstr, chrstr);
			//sv_catpvf(rv,"[%-4.4s]   %-*s %-*s\n", addrstr, hex_sz-1, hexstr, chr_sz-1, chrstr);
			hexstr[0] = 0; curhex = hexstr;
			chrstr[0] = 0; curchr = chrstr;
		} else if( every && ( n % every == 0 ) ) {
			/* half line: add whitespaces */
			my_snprintf(curhex, 1+hsp, "%-*s", hsp, ""); curhex += hsp;
			my_snprintf(curchr, 1+csp, "%-*s", csp, ""); curchr += csp;
		}
		p++; /* next byte */
	}
	
	if (curhex > hexstr) {
		/* print rest of buffer if not empty */
		//printf("[%4.4s]   %s  %s\n", addrstr, hexstr, chrstr);
		sv_catpvf(rv,"[%-4.4s]   %-*s %-*s\n", addrstr, hex_sz-1, hexstr, chr_sz-1, chrstr);
	}
	//warn("String length: %d, sv_sz=%d",SvCUR(rv),sv_sz);
	return rv;
}

#line 114 "Hexdump.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 166 "Hexdump.c"

XS(XS_Devel__Hexdump_xd); /* prototype to pass -Wmissing-prototypes */
XS(XS_Devel__Hexdump_xd)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       croak_xs_usage(cv,  "buf, ...");
    {
	SV *	buf = ST(0);
	SV *	RETVAL;
#line 111 "Hexdump.xs"
		STRLEN l;
		U8 *p;
		hexdump_conf cf;
		cf.row  = 16;
		cf.hpad = 1;
		cf.cpad = 0;
		cf.hsp  = 1;
		cf.csp  = 1;
		cf.cols   = 4;
		if (items > 1){
			if ( SvOK(ST(1)) && SvROK(ST(1)) && SvTYPE( SvRV( ST(1) ) ) == SVt_PVHV) {
				HV * conf = (HV *) SvRV(ST(1));
				SV **key;
				if ((key = hv_fetch(conf, "row", 3, 0)) && SvIOK(*key))  cf.row = SvIV(*key);
				if ((key = hv_fetch(conf, "hpad", 4, 0)) && SvIOK(*key)) cf.hpad = SvIV(*key);
				if ((key = hv_fetch(conf, "cpad", 4, 0)) && SvIOK(*key)) cf.cpad = SvIV(*key);
				if ((key = hv_fetch(conf, "hsp", 3, 0)) && SvIOK(*key))  cf.hsp = SvIV(*key);
				if ((key = hv_fetch(conf, "csp", 3, 0)) && SvIOK(*key)) cf.csp = SvIV(*key);
				if ((key = hv_fetch(conf, "cols", 4, 0)) && SvIOK(*key)) cf.cols = SvIV(*key);

			} else {
				croak("Usage: xd($buffer [, \%config ])");
			}
		}
		p = SvPV(buf,l);
		RETVAL = myhexdump(p, l, &cf);
#line 208 "Hexdump.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Devel__Hexdump); /* prototype to pass -Wmissing-prototypes */
XS(boot_Devel__Hexdump)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("Devel::Hexdump::xd", XS_Devel__Hexdump_xd, file, "$;$");
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

